#ifndef STRINGRESULT_H
#define STRINGRESULT_H

#include <QString>
#include "result.h"
/**
 * @brief The StringResult class stores command result for String.
 */
class StringResult : public Result
{
public:
    /**
     * @brief StringResult
     */
    StringResult();
	/**
	 * @brief StringResult
	 */
	virtual ~StringResult();
    /**
     * @brief setText
     * @param text
     */
    void setText(QString text);
    /**
     * @brief getText
     * @return
     */
    QString getText() const;
    /**
     * @brief getScalar
     * @return
     */
    virtual QVariant getResult(RESULT_TYPE);
    /**
     * @brief toString
     * @return
     */
    virtual QString toString();

    virtual void setHighLight(bool );
    virtual bool hasHighLight() const;
private:
    QString m_value;
    bool m_highlight;
};

#endif // STRINGRESULT_H
